//
// :                
// :      Microsoft Visual C++ v6.0
// :		1801BM1@gmail.com
//
// 14  2002
//        
//
#define __CMDLINE_INTERNAL__ 
#include "vnet32.h"

//#ifdef KEY_INFILE_BIT
//
//       
//       
//     ,  
//   .
//        TRUE
//
BOOL CL_SetFileName(char* Buf, char* Name)
{
    int Len;
	
	Len = strlen(Name);
    if (Len > MAX_FILE_NAME)
    {
        ERR_ShowError(ERR_FATAL"Too long filename\n\r");
        return TRUE;
    }
    strcpy(Buf, Name);

#ifdef DEF_FILE_EXT
    //
    // ,     
    // 
    if (strrchr(Buf, '.'))
        return FALSE;
    //
    //   ,   
    //      
    //
    if (Len >= (MAX_FILE_NAME - sizeof(DEF_FILE_EXT)))
    {
        ERR_ShowError(ERR_FATAL"Too long filename\n\r");
        return TRUE;
    }
    strcpy(Buf + Len, DEF_FILE_EXT); 
#endif

    return FALSE;
}

#ifdef KEY_INFILE_BIT
//
//    ,    
//   (  /  )  
//     ,  ,  
//        TRUE
//
BOOL CL_EnumerateFile(char* Key)
{
    if(CL_KeyPresent(KEY_INFILE_BIT))
    {
        //
        //    ()  
        // ,    
        //
#ifdef KEY_OUTFILE_BIT
        if(CL_KeyPresent(KEY_OUTFILE_BIT))
        {
            //
            //      - 
            //
            ERR_ShowError(ERR_FATAL"Too many filenames specified\n\r");
            return TRUE;
        }
        else
        {
            CLD_KeyMask |= KEY_OUTFILE_BIT;
            return CL_SetFileName(OutFileName, Key);
        }
#else
        //
        //     -  
        //
            ERR_ShowError(ERR_FATAL"Too many filenames specified\n\r");
            return TRUE;
#endif
    }
    else
    {
        CLD_KeyMask |= KEY_INFILE_BIT;
        return CL_SetFileName(InFileName, Key);
    }
}
#endif  // KEY_INFILE_BIT

//
//        
//      ,   
//  0     CLD_ConvError
//
//
DWORD CL_GetDecValue(char* Line)
{
    DWORD Value = 0;
    int i;

    //
    //   
    //
    CLD_ConvError = TRUE;
    //
    //   
    //
    while(*Line == '0') Line++;
    //
    //    9  ,   
    //     
    //
    for(i = 0; i < (sizeof(DWORD) * 2 + 1); i++)
    { 
        //
        //   
        //
        if (*Line == 0) break;
        if (!isdigit(*Line)) break;
        Value = Value * 10 + *Line - '0';
        Line++;
    }
    //
    //  , ,    
    // 
    if (*Line == 0)
    {
        CLD_ConvError = FALSE;
        return Value;
    }
    //
    //   
    //
    return 0;
}

//
//        
//      ,   
//  0     CLD_ConvError
//
DWORD CL_GetHexValue(char* Line)
{
    DWORD Value = 0;
    DWORD Add;

    //
    //   
    //
    CLD_ConvError = TRUE;
    //
    //    8  ,   
    //     
    //
    while (*Line)
    { 
        //
        //    
        //
        if (!isxdigit(*Line)) break;
        if (Value & (0xF0L << ((sizeof(DWORD) - 1)*8))) break;

        if (isdigit(*Line))
        {
            Add = *Line - '0';
        }
        else
        {
            Add = toupper(*Line) - 'A' + 10;
        }
        Value = (Value << 4) + Add;
        Line++;
    }
    //
    //  , ,    
    // 
    if (*Line == 0)
    {
        CLD_ConvError = FALSE;
        return Value;
    }
    //
    //   
    //
    return 0;
}

//
//   ,     ,
//     ,      .
//        TRUE
//
BOOL CL_ProcessKey(char* Key)
{
    char Chr;
    char *VPtr;
    PSWITCH_DESC Desc;

    Chr = *Key;
    Chr = toupper(Chr);

    for(Desc = &Switch[0]; Desc < &Switch[KEY_TAB_SIZE]; Desc++)
    {
        if (Desc->Letter == Chr)
        {   
            //
            //      
            //
            if (CL_KeyPresent(Desc->KeyBit))
            {
                //
                //       - 
                // 
                ERR_ShowError(ERR_FATAL"Multiple switch specification\n\r");
                return TRUE;
            }
            //
            //  ,    
            //
            CLD_KeyMask |= Desc->KeyBit;
            Desc->Flags |= SWFLG_PRESENT;

            VPtr = Key + 1;     //     

            switch(Desc->Type)
            {
//
//      
//
#ifdef SWTYP_NOVALUE
                case SWTYP_NOVALUE:
                {
                    if (*VPtr != 0)
                    {
                        ERR_ShowError(ERR_FATAL"Switch -%c has unexpected value\n\r", *Key);
                        return TRUE;
                    }
                    break;
                }
#endif SWTYP_NOVALUE

//
//      
//
#ifdef SWTYP_DECVALUE
                case SWTYP_DECVALUE:
                {
                    //
                    // ,       
                    //
                    if(Desc->Format & SWFMT_MUSTVALUE)
                    {
                        if (*VPtr == 0)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c must have value\n\r", *Key);
                            return TRUE;
                        }
                    }
                    if(*VPtr != 0)
                    {
                        //
                        //   
                        //
                        Desc->Value = CL_GetDecValue(VPtr);
                        if (CLD_ConvError)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c has invalid value\n\r", *Key);
                            return TRUE;
                        }
                        Desc->Flags |= SWFLG_HASVALUE;
                    }
                    break;
                }
#endif SWTYP_DECVALUE

//
//      
//
#ifdef SWTYP_HEXVALUE
                case SWTYP_HEXVALUE:
                {
                    //
                    // ,       
                    //
                    if(Desc->Format & SWFMT_MUSTVALUE)
                    {
                        if (*VPtr == 0)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c must have value\n\r", *Key);
                            return TRUE;
                        }
                    }
                    if(*VPtr != 0)
                    {
                        //
                        //   
                        //
                        Desc->Value = CL_GetHexValue(VPtr);
                        if (CLD_ConvError)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c has invalid value\n\r", *Key);
                            return TRUE;
                        }
                        Desc->Flags |= SWFLG_HASVALUE;
                    }
                    break;
                }
#endif SWTYP_HEXVALUE

//
//     
//
#ifdef SWTYP_STRING
                case SWTYP_STRING:
                {
                    //
                    // ,       
                    //
                    if(Desc->Format & SWFMT_MUSTVALUE)
                    {
                        if (*VPtr == 0)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c must have value\n\r", *Key);
                            return TRUE;
                        }
                    }
                    if(*VPtr != 0)
                    {
                        //
                        //   
                        //
                        Desc->Value = (DWORD)VPtr;
                        Desc->Flags |= SWFLG_HASVALUE;
                    }
                    break;
                }
#endif SWTYP_STRING

//
//         
//                
                default:
                    {
                        ERR_ShowError(ERR_DEBUG"Unknown switch type encountered\n\r");
                        return TRUE;
                    }
            }
            return FALSE;
        }
    }
    ERR_ShowError(ERR_FATAL"Unknown switch specified: -%s\n\r", Key);
    return TRUE;
}
//
//    ,   
//        TRUE
//
BOOL CL_EnumerateKey(char* Key)
{
    char C;
    
    C = *Key;
    if (!C)
    {
        ERR_ShowError(ERR_FATAL"Command line syntax error\n\r");
        return TRUE;
    }

    if ( (C != '-') && (C != '/'))
    {
    #ifdef  KEY_INFILE_BIT
        //
        //    ,   
        //
        return CL_EnumerateFile(Key);
    #else
        //
        //       ,   
        //
        ERR_ShowError(ERR_FATAL"Command line syntax error\n\r");
        return TRUE;
    #endif
    }

    Key++;
    C = *Key;

    if (!C)
    {
        ERR_ShowError(ERR_FATAL"Command line syntax error\n\r");
        return TRUE;
    }

    return CL_ProcessKey(Key);
}

//
//     
//
BOOL CL_CheckValues(void)
{
    PSWITCH_DESC Desc;

    for(Desc = &Switch[0]; Desc < &Switch[KEY_TAB_SIZE]; Desc++)
    {
        if ( ! Desc->Flags & SWFLG_PRESENT ) continue;
        //
        //     ,    
        //
        if ( ! Desc->Flags & SWFLG_HASVALUE) continue;
        
        switch(Desc->Type)
        {
//
//      ,   
//
#ifdef SWTYP_NOVALUE
                case SWTYP_NOVALUE:
                {
                    break;
                }
#endif SWTYP_NOVALUE

//
//      
//
#ifdef SWTYP_DECVALUE
                case SWTYP_DECVALUE:
                {
                    if(Desc->Format & SWFMT_LOWLIMIT)
                    {
                        if(Desc->Value < Desc->LowLimit)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c has value less than lower limit\n\r",
                                          Desc->Letter);
                            return TRUE;
                        }
                    }
                    if(Desc->Format & SWFMT_HIGHLIMIT)
                    {
                        if(Desc->Value > Desc->HighLimit)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c has value more than upper limit\n\r",
                                          Desc->Letter);
                            return TRUE;
                        }
                    }
                    //
                    //    
                    //
                    if (Desc->ValueProc != NULL)
                        if(Desc->ValueProc(Desc))
                            return TRUE;
                    break;
                }
#endif SWTYP_DECVALUE

//
//      
//
#ifdef SWTYP_HEXVALUE
                case SWTYP_HEXVALUE:
                {
                    if(Desc->Format & SWFMT_LOWLIMIT)
                    {
                        if(Desc->Value < Desc->LowLimit)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c has value less than lower limit\n\r",
                                          Desc->Letter);
                            return TRUE;
                        }
                    }
                    if(Desc->Format & SWFMT_HIGHLIMIT)
                    {
                        if(Desc->Value > Desc->HighLimit)
                        {
                            ERR_ShowError(ERR_FATAL"Switch -%c has value more than upper limit\n\r",
                                          Desc->Letter);
                            return TRUE;
                        }
                    }
                    //
                    //    
                    //
                    if (Desc->ValueProc != NULL)
                        if(Desc->ValueProc(Desc))
                            return TRUE;
                    break;
                }
#endif SWTYP_HEXVALUE

//
//     ,    
//   
//
#ifdef SWTYP_STRING
                case SWTYP_STRING:
                {
                    //
                    //    
                    //
                    if (Desc->ValueProc != NULL)
                        if(Desc->ValueProc(Desc))
                            return TRUE;
                    break;
                }
#endif SWTYP_STRING

//
//      SWTYP_xxxx    
//                
                default:
                    {
                        ERR_ShowError(ERR_DEBUG"Unknown switch type encountered\n\r");
                        return TRUE;
                    }
            } // switch
        } // for
    return FALSE;
}

//
//       
//   :
//  -  -    -  
//      ,    ;
//  -    
//  -     ;
//
BOOL CL_CheckCompatibility(void)
{
    PSWITCH_DESC Desc;

    for(Desc = &Switch[0]; Desc < &Switch[KEY_TAB_SIZE]; Desc++)
    {
        if ( ! Desc->Flags & SWFLG_PRESENT ) continue;
        if ( CLD_KeyMask & Desc->IncompKey )
        {
            ERR_ShowError(ERR_FATAL"Incompatible switch combination specified\n\r");
            return TRUE;
        }
        if ((CLD_KeyMask & Desc->RequireKey) != Desc->RequireKey)
        {
            ERR_ShowError(ERR_FATAL"Incomplete switch combination specified\n\r");
            return TRUE;
        }
        if (Desc->VerifyProc != NULL)
            if(Desc->VerifyProc(Desc))
                return TRUE;
    }
    return FALSE;
}

//
//     
//  ,    main()
//       
//  ERR_ShowText()    
//
BOOL CL_ParseCmdLine(int arg, char* argv[])
{
    int i;

    if (arg < 2)
    {   
        //
        //    
        // ,    
        //
        ERR_ShowHelp();
        return TRUE;
    }

    for (i = 1; i < arg; i++)           
    {
        //
        //        
        //
        if (CL_EnumerateKey(argv[i]))
		{
            return TRUE;
		}
    }

    //
    //       
    //    ,      
    // 
    // 
    if (CL_CheckValues()|| CL_CheckCompatibility())
	{
        return TRUE;
	}
    return FALSE;
}

//
//       ,  
//   ,   NULL
//
#ifdef  KEY_INFILE_BIT                  
char* CL_GetInFile(void)
{
    //
    // ,          
    //
    if (CL_KeyPresent(KEY_INFILE_BIT) && strlen(InFileName))
    {
        return &InFileName[0];
    }
    return NULL;
}

#ifdef  KEY_OUTFILE_BIT 
char* CL_GetOutFile(void)
{
    //
    // ,          
    //
    if (CL_KeyPresent(KEY_OUTFILE_BIT) && strlen(OutFileName))
    {
        return &OutFileName[0];
    }
    return NULL;
}
#endif                                  
#endif                                  

//
//       (  
//   ,     
//  ),      
// .     ,   NULL
//
//
PVOID CL_GetValuePtr(DWORD KeyBit)
{
    PSWITCH_DESC Desc;
    PVOID Result = NULL;

    for(Desc = &Switch[0]; Desc < &Switch[KEY_TAB_SIZE]; Desc++)
    {
        if(Desc->KeyBit == KeyBit)
        {
            if (!CL_KeyPresent(KeyBit))
            {
                //
                //         NULL
                //
                break;
            }

            if ((Desc->Flags & SWFLG_HASVALUE) == 0)
            {
                //
                //      -  
                //
                break;
            }

            switch(Desc->Type)
            {
//
//      
//
#ifdef SWTYP_NOVALUE
                case SWTYP_NOVALUE:
                {
                    break;
                }
#endif SWTYP_NOVALUE

//
//      
//
#ifdef SWTYP_DECVALUE
                case SWTYP_DECVALUE:
                {
                    Result = &Desc->Value;
                    break;
                }
#endif SWTYP_DECVALUE

//
//      
//
#ifdef SWTYP_HEXVALUE
                case SWTYP_HEXVALUE:
                {
                    Result = &Desc->Value;
                    break;
                }
#endif SWTYP_HEXVALUE

//
//    
//
#ifdef SWTYP_STRING
                case SWTYP_STRING:
                {
                    Result = (PVOID)(Desc->Value);
                    break;
                }
#endif SWTYP_STRING

//
//         
//                
                default:
                {
                    ERR_ShowError(ERR_DEBUG"Unknown switch type encountered\n\r");
                    break;
                }
            }
            break;
        }
    }
    return Result;
}
